/* ------------------------------------------------------------ */
/*
HTTrack Website Copier, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche, Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private information on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
from the company Serianet at Caen, France (http://www.serianet.com)

Please visit our Website: http://www.httrack.com
*/


/* ------------------------------------------------------------ */
/* File: httrack.c subroutines:                                 */
/*       hash table system (fast index)                         */
/* Author: Xavier Roche                                         */
/* ------------------------------------------------------------ */



#ifndef HTSHASH_DEFH
#define HTSHASH_DEFH 

#include "httrack.h"

// tables de hashage
int hash_read(hash_struct* hash,char* nom1,char* nom2,int type);
void hash_write(hash_struct* hash,int lpos);
int* hash_calc_chaine(hash_struct* hash,int type,int pos);
unsigned long int hash_cle(char* nom1,char* nom2);

// -- 

// simple hash table for other routines
typedef struct hash_chain {
  long int  pos;                 /* position */
  char value[HTS_URLMAXSIZE*2];  /* www.foo.com/secure/ */
  struct hash_chain* next;       /* next element */
} hash_chain;


void inthash_add(hash_chain** hash,int hash_size,char* str,long int e);
int  inthash_read(hash_chain** hash,int hash_size,char* str,long int* e);
void inthash_init(hash_chain** hash,int hash_size);
void inthash_del(hash_chain** hash,int hash_size);
void inthash_mdel(hash_chain** hash,int hash_size);
void inthash_delchain(hash_chain* hash,int free_int);


#endif
